
#include "stdafx.h"

#include "cv.h"
#include "simm.h"

const int number_of_particle = 500;
const double system_variance = 0.2;


int main( int argc, char** argv )
{
	const int T=1;
	IplImage * frame_tl = 0;
	CvMat mat, * image, * hsv, * hue;
	class simm simm_tracker;
	int first_frame_flag = 1;

	const char * Window_Name = "SIMM tracking DEMO";
	CvCapture* capture = cvCaptureFromAVI( "SIMM_DEMO.avi" );
	cvNamedWindow( Window_Name);
	for(;;)
    {
		IplImage * frame = cvQueryFrame( capture );
		if( !frame )
			break;
		if( !frame_tl )
        {
			frame_tl = cvCloneImage(frame);
			hsv = cvCreateMat( frame->height, frame->width, CV_8UC3 );
			hue = cvCreateMat( frame->height, frame->width, CV_8UC1 );
        }
		if( frame->origin != IPL_ORIGIN_TL )
		{
			cvFlip( frame, frame_tl);
			frame_tl->origin = IPL_ORIGIN_TL;
		}
		else
			cvCopy(frame, frame_tl);
		image = cvGetMat( frame_tl, &mat);
		cvCvtColor( image, hsv, CV_BGR2HSV );
		cvSplit( hsv, hue, 0, 0, 0 );
		simm_tracker.image = hue;

		if(first_frame_flag)
		{
			simm_tracker.init_tracker(hue,179,number_of_particle);
			simm_tracker.m_system_variance[0]=system_variance;
			simm_tracker.m_system_variance[1]=system_variance;
			simm_tracker.new_target(hue,135+T,260+T,20-T*2,20-T*2,1);
			simm_tracker.new_target(hue,215+T,230+T,20-T*2,20-T*2,2);
			simm_tracker.new_target(hue,258+T,156+T,20-T*2,20-T*2,3);
			simm_tracker.new_target(hue,243+T,73+T,20-T*2,20-T*2,4);
			simm_tracker.new_target(hue,177+T,18+T,20-T*2,20-T*2,5);
			simm_tracker.new_target(hue,93+T,18+T,20-T*2,20-T*2,6);
			simm_tracker.new_target(hue,27+T,73+T,20-T*2,20-T*2,7);
			simm_tracker.new_target(hue,12+T,156+T,20-T*2,20-T*2,8);
			simm_tracker.new_target(hue,55+T,230+T,20-T*2,20-T*2,9);
			first_frame_flag=0;
		}

		simm_tracker.process();

		simm_tracker.show(image);

		cvShowImage( Window_Name, image );
        int c = cvWaitKey(1);
        if( (char) c == 27 )
            break;
	}

	cvWaitKey(-1);
	cvReleaseCapture( &capture );
	cvDestroyWindow( Window_Name );

	return 1;
}

