#pragma once

#include <vector>


#include "misc.h"
#include "sample.h"

extern int mo_next_variable_parameter_id;

class Target
{
public:
	Target()
	{
		mo_id=0;mo_origin_width=mo_origin_height=0;
		m_subset_start=0;m_length=0;m_subset_length=0;m_subset_next_start=0;
		pj_bootstrap_bufs=0;
		pj_lut_size=0;
		pj_particle=0;
	}
	int get_next_id(void){return mo_next_variable_parameter_id;}
	void set_next_id(int id){mo_next_variable_parameter_id=id;}
	int get_id(void){return mo_id;}
	int assign_new_id(void)
	{
		if(mo_id==0 || mo_id==-1)
		{
			int id;
			id = get_next_id() + 1;
			set_next_id(id);
			mo_id=id;
			return mo_id;
		}
		return 0;
	}
	void clear_id(void){mo_id=-1;}
	float get_width(void){return mo_origin_width;}
	float get_height(void){return mo_origin_height;}
	void set_width(float w){mo_origin_width=w;}
	void set_height(float h){mo_origin_height=h;}

	void set_subset_idx(int start, int length)
	{
		assert(start>=0 && length >=1);
		m_subset_start=start;
		m_length=m_subset_length=length;
		m_subset_next_start=m_subset_start+m_subset_length;
	}
	int get_subset_start(void){return m_subset_start;}
	int get_subset_length(void){return m_subset_length;}
	int get_subset_end(void){return m_subset_start+m_subset_length-1;}
	int get_subset_next_start(void){return m_subset_next_start;}
	void set_length(int l){assert(l>0 && l<=m_subset_length);m_length=l;}
	int get_length(void){return m_length;}

	void likelihood_init(int hue_max)
	{
		temp_histogram.init(hue_max);
		temp_histogram.set(1);
		temp_histogram.normalize();
		reference_histogram.init(hue_max);
		reference_histogram.set(1);
		reference_histogram.normalize();
	}
	float likelihood_computing(CvRect rect, CvMat* image)
	{
		temp_histogram.set(0);
		temp_histogram.calc_2D(image,rect);
		temp_histogram.normalize();
		return reference_histogram.distance_from_2n(&temp_histogram);
	}
	void likelihood_copy_to_reference(CvRect rect, CvMat* image)
	{
		likelihood_computing(rect,image);
		reference_histogram.copy_from(&temp_histogram);
	}

	void init_pj_buf(int lut_size, int max_number_of_object)
	{
		lut_size++;
		if(pj_lut_size!=lut_size)
		{
			const int bootstrap_buffer_size = cvAlign(lut_size*sizeof(CvSample*),CV_MALLOC_ALIGN);
			uchar * p = (uchar *)cvAlloc(bootstrap_buffer_size);
			for(int i=0;i<bootstrap_buffer_size;i++) p[i]=0;
			pj_bootstrap_bufs = (void *)p;
			pj_lut_size = lut_size;
			pj_overlaped_objects.reserve(max_number_of_object);
		}
	}
	void * get_bootstrap_bufs(void){return pj_bootstrap_bufs;}
	
public:
	CvSample m_mean;
protected:
	int mo_id;
	float mo_origin_width;
	float mo_origin_height;

	int m_subset_start;
	int m_length;
	int m_subset_length;
	int m_subset_next_start;

	Histogram reference_histogram;
	Histogram temp_histogram;
	void * pj_bootstrap_bufs;
	int pj_lut_size;
public:
	CvSample * pj_particle;
	std::vector< Target * > pj_overlaped_objects;
	CVRECT2 pj_outer_rect2;
	int pj_interaction_flag;
	CvSample * pj_particle_ptr;
};